// enable double clicking from the Macintosh Finder or the Windows Explorer
#target photoshop

// in case we double clicked the file
app.bringToFront();

// Supress Photoshop dialogs
app.displayDialogs = DialogModes.NO;


function showAbout() {
	about = new Window('dialog', 'About', {x:200, y:250, width:200, height:130});

	about.info = about.add('panel', {x:10, y:10, width:180, height:110}, '');
	about.info.aSt = about.info.add('statictext', {x:10, y:10, width:280, height:20}, 'Quick Gallery');
	about.info.cSt = about.info.add('statictext', {x:10, y:30, width:280, height:20}, 'www.gieson.com');
	about.info.eSt = about.info.add('statictext', {x:10, y:50, width:280, height:20}, 'v2.1');	
	
	about.btnCanx = about.add('button', {x:20, y:85, width:50, height:20}, 'Close');
	about.btnCanx.onClick = function() { this.parent.close(0); }
	
	about.show();
}

dlg = new Window('dialog', 'Quick Gallery', {x:100, y:100, width:450, height:270});

var layoutTop = 20;
var layoutRowSpace = 30;
var layoutRowInputOffset = 2;
var layoutNextRow = layoutTop;

// Gallery Name
dlg.titleSt = dlg.add('statictext', {x:20, y:layoutNextRow, width:90, height:20}, 'Gallery Name:');
dlg.titleEt = dlg.add('edittext', {x:120, y:layoutNextRow-layoutRowInputOffset, width:310, height:20}, '', {name:'siteName'} );
dlg.titleEt.text = "Photos";

// --- next row ---
layoutNextRow += layoutRowSpace;

// Date
dlg.dateText = dlg.add('statictext', {x:20, y:layoutNextRow, width:90, height:20}, 'Date:');
dlg.dateTextInput = dlg.add('edittext', {x:120, y:layoutNextRow-layoutRowInputOffset, width:310, height:20}, '', {name:'siteName'} );

var months = ["Jan.", "Feb.", "Mar.", "Apr.", "May", "Jun.", "Jul.", "Aug.", "Sep.", "Oct.", "Nov.", "Dec."];
var currentTime = new Date();
var month = months[currentTime.getMonth()];
var day = currentTime.getDate();
var year = currentTime.getFullYear();
dlg.dateTextInput.text = month + " " + day + ", " + year;

// --- next row ---
layoutNextRow += layoutRowSpace;

// Source folder
dlg.srcSt = dlg.add('statictext', {x:20, y:layoutNextRow, width:100, height:20}, 'Source Folder:', {name:'sourceDir'} );
dlg.srcEt = dlg.add('edittext', {x:120, y:layoutNextRow-layoutRowInputOffset, width:240, height:20}, '', {name:'sourceDir'} );
dlg.srcBtn = dlg.add('button', {x:370, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, 'Set', {name: 'browseSource'} );
dlg.srcBtn.onClick = function() {
	setSrcDir = Folder.selectDialog("Select the Images Source Folder");
	if ( setSrcDir != null ) {dlg.srcEt.text = setSrcDir.fsName }
}
dlg.srcEt.text = "C:\\_galleryTank\\source";

// --- next row ---
layoutNextRow += layoutRowSpace;

// Output folder
dlg.outSt = dlg.add('statictext', {x:20, y:layoutNextRow, width:100, height:20}, 'Output Folder:', );
dlg.outEt = dlg.add('edittext', {x:120, y:layoutNextRow-layoutRowInputOffset, width:240, height:20}, '', {name:'outputDir'} );
dlg.outBtn = dlg.add('button', {x:370, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, 'Set', {name:'browseOutput'} );
dlg.outBtn.onClick = function() {
	setOutDir = Folder.selectDialog("Select the Gallery Output Folder");
	if ( setOutDir != null ) {dlg.outEt.text = setOutDir.fsName }
}
dlg.outEt.text = "C:\\_galleryTank\\browse";

// --- next row ---
layoutNextRow += layoutRowSpace;

// Grid
dlg.gridText = dlg.add('statictext', {x:20, y:layoutNextRow, width:60, height:20}, 'Grid:');
dlg.gridTextRows = dlg.add('statictext', {x:125, y:layoutNextRow, width:40, height:20}, 'Rows:');
dlg.gridTextRowsInput = dlg.add('edittext', {x:165, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, '', {name:'gridRows'} );
dlg.gridTextRowsInput.text = "3";
dlg.gridTextCols = dlg.add('statictext', {x:235, y:layoutNextRow, width:50, height:20}, 'Cols:');
dlg.gridTextColsInput = dlg.add('edittext', {x:305, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, '', {name:'gridCols'} );
dlg.gridTextColsInput.text = "3";

// --- next row ---
layoutNextRow += layoutRowSpace;

// Size
dlg.sizeSt = dlg.add('statictext', {x:20, y:layoutNextRow, width:60, height:20}, 'Sizes:');
dlg.sizeStL = dlg.add('statictext', {x:125, y:layoutNextRow, width:40, height:20}, 'Large:');
dlg.sizeEtL = dlg.add('edittext', {x:165, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, '', {name:'siteLarge'} );
dlg.sizeEtL.text = "800";
dlg.sizeStT = dlg.add('statictext', {x:235, y:layoutNextRow, width:50, height:20}, 'Thumb:');
dlg.sizeEtT = dlg.add('edittext', {x:305, y:layoutNextRow-layoutRowInputOffset, width:60, height:20}, '', {name:'sizeThumb'} );
dlg.sizeEtT.text = "200";

// --- next row ---
layoutNextRow += layoutRowSpace;

// About Button
dlg.btnAbt = dlg.add('button', {x:15, y:layoutNextRow, width:90, height:15}, 'About');
dlg.btnAbt.onClick = function() { showAbout(); };

// Create Gallery Button
dlg.btnOK = dlg.add('button', {x:120, y:layoutNextRow, width:310, height:50}, 'Create Gallery!' );
dlg.btnOK.onClick = function() {
	runGallery();
}

// --- next row ---
layoutNextRow += layoutRowSpace;

// Close Button
dlg.btnCanx = dlg.add('button', {x:15, y:layoutNextRow, width:90, height:15}, 'Close');
dlg.btnCanx.onClick = function() { this.parent.close(0); };



dlg.show();

function yourOS() {
    var ua = navigator.userAgent.toLowerCase();
    if (ua.indexOf("win") != -1) {
        return "Windows";
    } else if (ua.indexOf("mac") != -1) {
        return "Macintosh";
    } else if (ua.indexOf("linux") != -1) {
        return "Linux";
    } else if (ua.indexOf("x11") != -1) {
        return "Unix";
    } else {
        return "Computers";
    }
}

alert(yourOS());



function runGallery() {

var varBigSize = parseFloat(dlg.sizeEtL.text);
var varLittleSize = parseFloat(dlg.sizeEtT.text);
var varTitle = String(dlg.titleEt.text);
var varSourceDir = String(dlg.sourceDir.text);
var varOutputDir = String(dlg.outputDir.text);
var myDate = String(dlg.dateTextInput.text);

var totalRows = parseFloat(dlg.gridTextRowsInput.text);
var totalColums = parseFloat(dlg.gridTextColsInput.text);

if(varBigSize < 0){
	varBigSize = 800.00;
}

if(varLittleSize < 0){
	varLittleSize = 200.00;
}

var id78 = stringIDToTypeID( "4C1ABF41-DD82-11d2-B20F-0008C75B322C" );
    var desc3 = new ActionDescriptor();
    var id79 = charIDToTypeID( "Stln" );
    desc3.putString( id79, "Quick Gallery" );
    var id80 = charIDToTypeID( "kOtm" );
    var id81 = charIDToTypeID( "OpMu" );
    var id82 = charIDToTypeID( "OpCl" );
    desc3.putEnumerated( id80, id81, id82 );
    var id83 = charIDToTypeID( "emil" );
    desc3.putString( id83, "" );
    var id84 = charIDToTypeID( "Extn" );
    var id85 = charIDToTypeID( "Exsn" );
    var id86 = charIDToTypeID( "html" );
    desc3.putEnumerated( id84, id85, id86 );
    var id87 = charIDToTypeID( "utf8" );
    desc3.putBoolean( id87, true );
    var id88 = charIDToTypeID( "prmd" );
    desc3.putBoolean( id88, false );
    var id89 = charIDToTypeID( "Stnm" );
    
    // from dialog
    desc3.putString( id89, varTitle );
    var id90 = charIDToTypeID( "Ptgf" );
    desc3.putString( id90, "" );
    var id91 = charIDToTypeID( "CtIf" );
    desc3.putString( id91, "" );
    var id92 = charIDToTypeID( "Date" );
    desc3.putString( id92, myDate );
    var id93 = charIDToTypeID( "BnFt" );
    var id94 = charIDToTypeID( "Font" );
    var id95 = charIDToTypeID( "Aril" );
    desc3.putEnumerated( id93, id94, id95 );
    var id96 = charIDToTypeID( "BnFs" );
    var id97 = charIDToTypeID( "FtSz" );
    var id98 = charIDToTypeID( "Fts2" );
    desc3.putEnumerated( id96, id97, id98 );
    var id99 = charIDToTypeID( "InpD" );

    // from dialog
    desc3.putPath( id99, new File( varSourceDir ) );
    var id100 = charIDToTypeID( "InSd" );
    desc3.putBoolean( id100, false );
    var id101 = charIDToTypeID( "OutD" );

    // from dialog
    desc3.putPath( id101, new File( varOutputDir ) );
    var id102 = charIDToTypeID( "WdHt" );
    desc3.putBoolean( id102, true );
    var id103 = charIDToTypeID( "ImBr" );
    desc3.putInteger( id103, 0 );
    var id104 = charIDToTypeID( "NmLk" );
    desc3.putBoolean( id104, true );
    var id105 = charIDToTypeID( "RsIm" );
    desc3.putBoolean( id105, true );
    var id106 = charIDToTypeID( "ImDm" );
    var id107 = charIDToTypeID( "#Pxl" );

    // from dialog 
    desc3.putUnitDouble( id106, id107, varBigSize );
    var id108 = charIDToTypeID( "kCst" );
    var id109 = charIDToTypeID( "Cstr" );
    var id110 = charIDToTypeID( "CsBt" );
    desc3.putEnumerated( id108, id109, id110 );
    var id111 = charIDToTypeID( "QEdt" );
    desc3.putInteger( id111, 5 );
    var id112 = charIDToTypeID( "NaIm" );
    desc3.putBoolean( id112, true );
    var id113 = charIDToTypeID( "CtIm" );
    desc3.putBoolean( id113, false );
    var id114 = charIDToTypeID( "CrIm" );
    desc3.putBoolean( id114, false );
    var id115 = charIDToTypeID( "TlIm" );
    desc3.putBoolean( id115, false );
    var id116 = charIDToTypeID( "CpIm" );
    desc3.putBoolean( id116, false );
    var id117 = charIDToTypeID( "FtIm" );
    var id118 = charIDToTypeID( "Font" );
    var id119 = charIDToTypeID( "Aril" );
    desc3.putEnumerated( id117, id118, id119 );
    var id120 = charIDToTypeID( "FzIm" );
    var id121 = charIDToTypeID( "FtSz" );
    var id122 = charIDToTypeID( "Fts3" );
    desc3.putEnumerated( id120, id121, id122 );
    var id123 = charIDToTypeID( "IndN" );
    desc3.putBoolean( id123, false );
    var id124 = charIDToTypeID( "InCp" );
    desc3.putBoolean( id124, false );
    var id125 = charIDToTypeID( "InCr" );
    desc3.putBoolean( id125, false );
    var id126 = charIDToTypeID( "InTl" );
    desc3.putBoolean( id126, false );
    var id127 = charIDToTypeID( "InCT" );
    desc3.putBoolean( id127, false );
    var id128 = charIDToTypeID( "CnFt" );
    var id129 = charIDToTypeID( "Font" );
    var id130 = charIDToTypeID( "Aril" );
    desc3.putEnumerated( id128, id129, id130 );
    var id131 = charIDToTypeID( "CnFs" );
    var id132 = charIDToTypeID( "FtSz" );
    var id133 = charIDToTypeID( "Fts1" );
    desc3.putEnumerated( id131, id132, id133 );
    var id134 = charIDToTypeID( "ThSz" );
    var id135 = charIDToTypeID( "ThSz" );
    var id136 = charIDToTypeID( "ThCt" );
    desc3.putEnumerated( id134, id135, id136 );
    var id137 = charIDToTypeID( "ThDm" );
    var id138 = charIDToTypeID( "#Pxl" );

    // from dialog
    desc3.putUnitDouble( id137, id138, varLittleSize );
    var id139 = charIDToTypeID( "NmCl" );
    desc3.putInteger( id139, totalColums );
    var id140 = charIDToTypeID( "NmRw" );
    desc3.putInteger( id140, totalRows );
    var id141 = charIDToTypeID( "TbBr" );
    desc3.putInteger( id141, 0 );
    var id142 = charIDToTypeID( "BgCl" );
    desc3.putString( id142, "#FFFFFF" );
    var id143 = charIDToTypeID( "BnCl" );
    desc3.putString( id143, "#F0F0F0" );
    var id144 = charIDToTypeID( "TxCl" );
    desc3.putString( id144, "#000000" );
    var id145 = charIDToTypeID( "ALCl" );
    desc3.putString( id145, "#FF0000" );
    var id146 = charIDToTypeID( "LkCl" );
    desc3.putString( id146, "#0000FF" );
    var id147 = charIDToTypeID( "VLCl" );
    desc3.putString( id147, "#800080" );
    var id148 = charIDToTypeID( "kSTt" );
    var id149 = charIDToTypeID( "ScTy" );
    var id150 = charIDToTypeID( "ScNn" );
    desc3.putEnumerated( id148, id149, id150 );
executeAction( id78, desc3, DialogModes.NO );
}